//---------------------------------main.cpp-----------------------------------
//	Programmer's Name: Brandon Wilson
//	Date: 12/10/06						Date of Last Modification: 12/10/06
//	E-mail Address: zblw7@imail.etsu.edu
//----------------------------------------------------------------------------
//	Purpose: none :)
//----------------------------------------------------------------------------
//	Notes: None
//----------------------------------------------------------------------------
#include <windows.h>
#include "..\winamp\wa_ipc.h"

#include "vis.h"

short _stdcall Inp32( short PortAddress );
void _stdcall Out32( short PortAddress, short data );

//configuration declarations
void config_read( struct winampVisModule *this_mod ); // reads the configuration
void config_write( struct winampVisModule *this_mod ); // writes the configuration
BOOL CALLBACK ConfigProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);

//returns a winampVisModule when requested
winampVisModule* getModule( int which );

//"member" functions
void config( struct winampVisModule *this_mod ); //configuration dialog
int init( struct winampVisModule *this_mod ); //initialization for module
int render( struct winampVisModule *this_mod ); //rendering for module
void quit( struct winampVisModule *this_mod) ; //deinitialization for module

//Module header, includes version, description, and address of the module retriever function
winampVisHeader hdr = { VIS_HDRVER, "Wii Gift Card Controller v1.0", getModule };

winampVisModule mod1 =
{
	"Default",
	NULL,	// hwndParent
	NULL,	// hDllInstance
	0,		// sRate
	0,		// nCh
	25,		// latencyMS
	25,		// delayMS
	0,		// spectrumNch
	2,		// waveformNch
	{ 0, },	// spectrumData
	{ 0, },	// waveformData
	config,
	init,
	render,
	quit
};

#ifdef __cplusplus
extern "C" {
#endif
__declspec( dllexport ) winampVisHeader *winampVisGetHeader()
{
	return &hdr;
}
#ifdef __cplusplus
}
#endif

//getmodule routine from the main header. Returns NULL if an invalid module was requested
winampVisModule* getModule( int which )
{
	if( which == 0 )
		return &mod1;
	return NULL;
}

void config(struct winampVisModule *this_mod)
{
	MessageBox( this_mod->hwndParent, "Wii Gift Card Controller\nv1.0\nBrandon Wilson\n12/10/06", "About", MB_ICONINFORMATION );
}

winampVisModule* g_mod = NULL;

int init( struct winampVisModule* this_mod )
{
	return 0;
}

int render( struct winampVisModule* this_mod )
{
	int x, y;
	for( y = 0; y < 2; y++ )
	{
		int last = this_mod->waveformData[y][0];
		int total = 0;
		for( x = 1; x < 576; x++ )
		{
			total += abs(last - this_mod->waveformData[y][x]);
			last = this_mod->waveformData[y][x];
		}
		total /= 288;
		if( total > 32 )
			Out32( 0x378, 0 );
		else
			Out32( 0x378, 1 );
	}
	return 0;
}

void quit(struct winampVisModule *this_mod)
{
	Out32( 0x378, 1 );
	return;
}

void config_read( struct winampVisModule *this_mod )
{
}

void config_write( struct winampVisModule *this_mod )
{
}